<template>
  <div class="invcards">
    <h4 v-if="user" >Welcome, {{user.first_name}} {{user.last_name}}.</h4>
    <h5>You can manage your inventories here.</h5><br>
    <div class="card-group" style="margin: 0 5% 0 5%;">
      <!-- This is a for-loop that cycles through an array of inventories and displays each one
      on a card. The card is a boostrap card built in the invcard component. -->
      <div class="card-group" v-for="inventory in inventories" :key="inventory" style="margin: 0 5px 0 5px;">
          <Invcard :id=inventory.inventory_id
          :body=inventory.description
          :user_id=user_id
          @delete-inventory="deleteSelectedInventory"
          @open-inventory="openSelectedInventory"
          @selected-inventory="sendInventory"
          />
      </div>
      <button type="button" class="btn btn-dark button" style="height: 50px;" data-toggle="modal" data-target="#createInventoryModal">New Inventory</button>

      <!-- Here starts the code for the modal in charge of creating new inventories. This modal is a
      pop up window containing a form. The code gathers all the data from the form and fires a method.-->
      <div class="modal fade" id="createInventoryModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
          <div class="modal-content">
            <div class="modal-header bg-dark">
              <h4 class="modal-title" id="exampleModalLongTitle" style="color: white;">New inventory: </h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close" style="color:white;">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body bg-dark">
              <!-- This is the form used to create a new inventory. -->
              <form class="auth-inner bg-secondary" id="inventoryData" @submit="createInventory">
                <div class="form-group">
                    <label>Description: </label>
                    <input type="text" class="form-control" v-model="description" placeholder='"This is my new inventory."' required/>
                </div>
                <div class="form-group">
                    <label>[Optional] Custom column: </label>
                    <input type="text" class="form-control" v-model="customColumnOne" placeholder="A title for your column."/>
                </div>
                <div class="form-group">
                    <label>[Optional] Custom column: </label>
                    <input type="text" class="form-control" v-model="customColumnTwo" placeholder="A title for your column."/>
                </div>
              </form>
            </div>
            <div class="modal-footer bg-dark">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              <button type="submit" class="btn btn-primary" form="inventoryData" id="createInv">Create</button>
            </div>
          </div>
        </div>
      </div>
      <!-- Here ends the code for the modal. -->
    </div>
  </div>
</template>

<script>
// Importing axios to make requests to the backend.
import Invcard from '../components/Invcard.vue'
import $ from 'jquery'
import axios from 'axios'
export default {
  name: 'Profile',
  // 'props' are properties (variables) inherited from parent components.
  props: ['user'],
  components: {
    Invcard
  },
  data () {
    return {
      baseUrl: 'http://localhost:8000/api/',
      inventory: null,
      inventories: [],
      user_id: this.user.user_id,
      description: '',
      customColumnOne: '',
      customColumnTwo: ''
    }
  },
  methods: {
    // This is the method fired when the user presses the create button in the create inventory modal.
    async createInventory () {
      await axios.post(this.baseUrl + 'inventories', {
        user_id: this.user_id,
        description: this.description,
        customColumnOne: this.customColumnOne,
        customColumnTwo: this.customColumnTwo
      })
      $('#createInventoryModal').modal('hide')
      this.$router.push('/')
    },
    // Each inventory card contains a 'list' button that opens the item list in that inventory in another page.
    openSelectedInventory (id) {
      axios.get(this.baseUrl + 'inventory', {
        params: {
          inventory_id: id
        }
      }).then(response => {
        this.inventory = response.data
        this.$emit('select-inventory', this.inventory[0])
        this.$router.push('/inventory/' + this.inventory[0].inventory_id)
      })
    },
    // Method called from child component to fire the PUT request to the backend.
    editSelectedInventory (id, desc, cco, cct) {
      axios.put('http://localhost:8000/api/inventories', {
        user_id: this.user.user_id,
        inventory_id: id,
        description: desc,
        customColumnOne: cco,
        customColumnTwo: cct
      })
    },
    // Each card contains a 'trash' button that fires this code when pressed.
    deleteSelectedInventory (id) {
      axios.delete(this.baseUrl + 'inventories', {
        params: {
          inventory_id: id
        }
      })
      this.$router.push('/')
    },
    // This is an emit method that send information from the child component (invcard.vue) to the
    // parent component (app.vue)
    sendInventory (y) {
      console.log(y)
      this.$emit('selected-item', null, y)
      this.$router.push('/profile/' + this.user.user_id + '/edit')
    }
  },
  // This mounted method is the main method of the profile page, it runs automatically when the page
  // is loaded. The code reaches to the backend and asks for all inventories related to the logged user.
  mounted () {
    axios.get(this.baseUrl + 'inventories', {
      params: {
        user_id: this.user.user_id
      }
    }).then(response => {
      this.inventories = response.data
    })
  }
}
</script>

<style scoped>
  .button {
    height: auto;
    margin: 2%;
  }
  .modal-header {
    border-bottom: 0 none;
    padding-bottom: 0;
  }
  .modal-footer {
    border-top: 0 none;
    padding-top: 0;
  }
  .invcards {
    color: whitesmoke;
  }
</style>
